      SUBROUTINE GXX( RZZ,RH,A,A2,IRA,G1,G1P,G2,G2P,G3,GZP)
C ***
C     SEGMENT END CONTRIBUTIONS FOR EXT. THIN WIRE APPROX.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      PARAMETER (PI=3.141592653589793D0)
      COMPLEX*16  GZ, C1, C2, C3, G1, G1P, G2, G2P, G3, GZP

      R2= RZZ* RZZ+ RH* RH
      R= SQRT( R2)
      R4= R2* R2
      RK= 2*PI* R
      RK2= RK* RK
      RH2= RH* RH
      T1=( A2* RH2/ R4)/4
      T2=(A2/ R2)/2
      C1= CMPLX(1.D0, RK)
      C2=3.* C1- RK2
      C3= CMPLX(6.D0, RK)* RK2-15.* C1
      GZ= CMPLX( COS( RK),- SIN( RK))/ R
      G2= GZ*(1.+ T1* C2)
      G1= G2- T2* C1* GZ
      GZ= GZ/ R2
      G2P= GZ*( T1* C3- C1)
      GZP= T2* C2* GZ
      G3= G2P+ GZP
      G1P= G3* RZZ
      IF( IRA.EQ.1) GOTO 2
      G3=( G3+ GZP)* RH
      GZP=- RZZ* C1* GZ
      IF( RH.GT.1.D-10) GOTO 1
      G2=0.
      G2P=0.
      RETURN
    1 G2= G2/ RH
      G2P= G2P* RZZ/ RH
      RETURN
    2 T2=.5* A
      G2=- T2* C1* GZ
      G2P= T2* GZ* C2/ R2
      G3= RH2* G2P- A* GZ* C1
      G2P= G2P* RZZ
      GZP=- RZZ* C1* GZ
      RETURN
      END
