      SUBROUTINE MOVE( ROX, ROY, ROZ, XS, YS, XZS, ITS, NRPT, ITGI)
C ***
C
C     SUBROUTINE MOVE MOVES THE STRUCTURE WITH RESPECT TO ITS
C     COORDINATE SYSTEM OR REPRODUCES STRUCTURE IN NEW POSITIONS.
C     STRUCTURE IS ROTATED ABOUT X,Y,Z AXES BY ROX,ROY,ROZ
C     RESPECTIVELY, THEN SHIFTED BY XS,YS,XZS
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      COMMON  /ANGL/ SALP( NM)
      DIMENSION X2(NM),Y2(NM),XZ2(NM)
      EQUIVALENCE(X2(1),SI(1)),(Y2(1),ALP(1)),(XZ2(1),BET(1))
      EQUIVALENCE(T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),(T2Y,ICON2),(
     &T2Z,ITAG)
      IF( ABS( ROX)+ ABS( ROY).GT.1.D-10) IPSYM= IPSYM*3
      SPS= SIN( ROX)
      CPS= COS( ROX)
      STH= SIN( ROY)
      CTH= COS( ROY)
      SPH= SIN( ROZ)
      CPH= COS( ROZ)
      XX= CPH* CTH
      XY= CPH* STH* SPS- SPH* CPS
      XZ= CPH* STH* CPS+ SPH* SPS
      YX= SPH* CTH
      YY= SPH* STH* SPS+ CPH* CPS
      YZ= SPH* STH* CPS- CPH* SPS
      UZX=- STH
      UZY= CTH* SPS
      UZZ= CTH* CPS
      NRP= NRPT
      IF( NRPT.EQ.0) NRP=1
      I1= ISEGNO( ITS,1)
      IX= I1
      K= N
      IF( NRPT.EQ.0) K= I1-1
      DO 2  IR=1, NRP
      DO 1  I= I1, N
      K= K+1
      IF(K.GT.NM)GOTO 944
      XI= X( I)
      YI= Y( I)
      UZI= RXZ( I)
      X( K)= XI* XX+ YI* XY+ UZI* XZ+ XS
      Y( K)= XI* YX+ YI* YY+ UZI* YZ+ YS
      RXZ( K)= XI* UZX+ YI* UZY+ UZI* UZZ+ XZS
      XI= X2( I)
      YI= Y2( I)
      UZI= XZ2( I)
      X2( K)= XI* XX+ YI* XY+ UZI* XZ+ XS
      Y2( K)= XI* YX+ YI* YY+ UZI* YZ+ YS
      XZ2( K)= XI* UZX+ YI* UZY+ UZI* UZZ+ XZS
      BI( K)= BI( I)
      BI0(K)=BI0(I)
      ITAG( K)= ITAG( I)
      IF( ITAG( I).NE.0) ITAG( K)= ITAG( I)+ ITGI
    1 CONTINUE
      I1= N+1
      N= K
    2 CONTINUE

    3 IF(( NRPT.EQ.0).AND.( IX.EQ.1)) RETURN
      NP= N
      IPSYM=0
      RETURN
 944  WRITE(*,*)'Too many segments (move structure)'
      STOP
      END
