      SUBROUTINE FBLOCK( NROW, NCOL, IPSYM)
C     FBLOCK SETS PARAMETERS FOR OUT-OF-CORE SOLUTION FOR THE PRIMARY
C     MATRIX (A)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'matpar.inc'
      COMMON  /SMAT/ ZSSX(16,16)
      DATA   PI/3.141592653589793D0/
      TP=2*PI
      IMAT= NROW* NCOL
      IF(IMAT.LE.NM*NM) GOTO 2
      WRITE(*,*)'TOO MANY SEGMENTS'
      STOP
 2    NBLOKS=1
      NPBLK= NROW
      NLAST= NROW
      IF( NROW.NE. NCOL) GOTO 1
      ICASE=1
      RETURN
    1 ICASE=2
      GOTO 5
    5 NOP= NCOL/ NROW
      IF( NOP* NROW.EQ. NCOL) GOTO 13
      WRITE(*,*)' SYMMETRY ERROR - NROW,NCOL=',NROW,NCOL
      STOP
C     SET UP ZSSX MATRIX FOR ROTATIONAL SYMMETRY.
 13   IF( IPSYM.GT.0) GOTO 7
      PHAZ=TP/NOP
      DO 6  I=2, NOP
      DO 6  J= I, NOP
      ARG= PHAZ* DFLOAT( I-1)* DFLOAT( J-1)
      ZSSX( I, J)= CMPLX( COS( ARG), SIN( ARG))
    6 ZSSX( J, I)= ZSSX( I, J)
C     SET UP ZSSX MATRIX FOR PLANE SYMMETRY
      GOTO 11
    7 KK=1
      ZSSX(1,1)=(1.,0.)
      IF(( NOP.EQ.2).OR.( NOP.EQ.4).OR.( NOP.EQ.8)) GOTO 8
      STOP
    8 KA= NOP/2
      IF( NOP.EQ.8) KA=3
      DO 10  K=1, KA
      DO 9  I=1, KK
      DO 9  J=1, KK
      ZDETER= ZSSX( I, J)
      ZSSX( I, J+ KK)= ZDETER
      ZSSX( I+ KK, J+ KK)=- ZDETER
    9 ZSSX( I+ KK, J)= ZDETER
   10 KK= KK*2
   11 CONTINUE
      RETURN
      END
